#include <cstdlib>
#include <cstdio>

#include "code.hpp"

float cmpx_add_f( float a, float b )
{
	return cmpx_add<float>(a,b);
}

int cmpx_add_i( int a, int b )
{
	return cmpx_add<int>(a,b);
}

A::A()
{
	this->p = (char *)malloc(1024);
}

A::~A()
{
	printf("Free Class Baby!!!\n");
	if (this->p != NULL)
	{
		free( this->p);
	}
}

void A::add( int a, int b )
{
	int i = cmpx_add_i( a , b );
	printf("%d\n", i);
}

bool A::empty()
{
	if (this->p == NULL)
	{
		return true;
	}
	else 
	{
		return false;
	}
}

extern void* clA_init()
{
	A *a = new A;
	return (void *)a;
}


extern void clA_add( void *c, int a, int b )
{
	A *cl=(A*)c;
	cl->add( a, b );
}

extern int clA_empty( void *c )
{
	A *cl=(A*)c;
	bool b = cl->empty();
	if ( b == true ) 
	{
		return 1;
	} else
	{
		return 0;
	}
}

extern void clA_destroy( void *c )
{
	A *cl = (A*)c;
	cl->~A();
}

extern void raise_exception( int a )
{
	try
	{
		int b;
		b = b/a;
		printf("Everything ok ;]\n");
	}
	catch ( int e )
	{
		printf("Catching up exception number %d \n",e);
	}
}


